# Add a user via a signup token POST https://app.unleash-instance.example.com/invite/{token}/signup Content-Type: application/json Create a user with the viewer root role and link them to the provided signup token Reference: https://docs.getunleash.io/api/add-public-signup-token-user ## OpenAPI Specification ```yaml openapi: 3.1.1 info: title: Add a user via a signup token version: endpoint_publicSignupTokens.addPublicSignupTokenUser paths: /invite/{token}/signup: post: operationId: add-public-signup-token-user summary: Add a user via a signup token description: >- Create a user with the viewer root role and link them to the provided signup token tags: - - subpackage_publicSignupTokens parameters: - name: token in: path required: true schema: type: string - name: Authorization in: header description: Header authentication of the form `undefined ` required: true schema: type: string responses: '200': description: userSchema content: application/json: schema: $ref: '#/components/schemas/userSchema' '400': description: The request data does not match what we expect. content: {} '409': description: >- The provided resource can not be created or updated because it would conflict with the current state of the resource or with an already existing resource, respectively. content: {} requestBody: description: createInvitedUserSchema content: application/json: schema: $ref: '#/components/schemas/createInvitedUserSchema' components: schemas: createInvitedUserSchema: type: object properties: username: type: string description: The user's username. Must be unique if provided. email: type: string description: The invited user's email address name: type: string description: The user's name password: type: string description: The user's password required: - email - name - password UserSchemaAccountType: type: string enum: - value: User - value: Service Account userSchema: type: object properties: id: type: integer description: The user id name: type: - string - 'null' description: Name of the user email: type: string description: Email of the user username: type: - string - 'null' description: A unique username for the user imageUrl: type: string description: URL used for the user profile image inviteLink: type: string description: >- If the user is actively inviting other users, this is the link that can be shared with other users loginAttempts: type: integer description: How many unsuccessful attempts at logging in has the user made emailSent: type: boolean description: Is the welcome email sent to the user or not rootRole: type: integer description: >- Which [root role](https://docs.getunleash.io/concepts/rbac#predefined-roles) this user is assigned seenAt: type: - string - 'null' format: date-time description: The last time this user logged in createdAt: type: string format: date-time description: The user was created at this time accountType: $ref: '#/components/schemas/UserSchemaAccountType' description: A user is either an actual User or a Service Account permissions: type: array items: type: string description: Deprecated scimId: type: - string - 'null' description: The SCIM ID of the user, only present if managed by SCIM seatType: type: - string - 'null' description: The seat type of this user companyRole: type: - string - 'null' description: The role of the user within the company. productUpdatesEmailConsent: type: - boolean - 'null' description: Whether the user has consented to receive product update emails. activeSessions: type: - integer - 'null' description: Count of active browser sessions for this user deletedSessions: type: number format: double description: >- Experimental. The number of deleted browser sessions after last login required: - id ``` ## SDK Code Examples ```python import requests url = "https://app.unleash-instance.example.com/invite/token/signup" payload = { "email": "hunter@example.com", "name": "Hunter Burgan", "password": "hunter2" } headers = { "Authorization": "", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://app.unleash-instance.example.com/invite/token/signup'; const options = { method: 'POST', headers: {Authorization: '', 'Content-Type': 'application/json'}, body: '{"email":"hunter@example.com","name":"Hunter Burgan","password":"hunter2"}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://app.unleash-instance.example.com/invite/token/signup" payload := strings.NewReader("{\n \"email\": \"hunter@example.com\",\n \"name\": \"Hunter Burgan\",\n \"password\": \"hunter2\"\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://app.unleash-instance.example.com/invite/token/signup") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"email\": \"hunter@example.com\",\n \"name\": \"Hunter Burgan\",\n \"password\": \"hunter2\"\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://app.unleash-instance.example.com/invite/token/signup") .header("Authorization", "") .header("Content-Type", "application/json") .body("{\n \"email\": \"hunter@example.com\",\n \"name\": \"Hunter Burgan\",\n \"password\": \"hunter2\"\n}") .asString(); ``` ```php request('POST', 'https://app.unleash-instance.example.com/invite/token/signup', [ 'body' => '{ "email": "hunter@example.com", "name": "Hunter Burgan", "password": "hunter2" }', 'headers' => [ 'Authorization' => '', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://app.unleash-instance.example.com/invite/token/signup"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"email\": \"hunter@example.com\",\n \"name\": \"Hunter Burgan\",\n \"password\": \"hunter2\"\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "", "Content-Type": "application/json" ] let parameters = [ "email": "hunter@example.com", "name": "Hunter Burgan", "password": "hunter2" ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/invite/token/signup")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```